import '../src/common_modes.dart';
import '../src/mode.dart';

final prolog = Mode(refs: {
  '~contains~2~contains~4~contains~9': Mode(className: "string", begin: "`", end: "`", contains: [backSlashEscape]),
  '~contains~2~contains~4~contains~5': Mode(className: "comment", begin: "%", end: "\$", contains: [phrasalWordsMode]),
  '~contains~2~contains~4~contains~11': Mode(className: "string", begin: "0\\'\\\\s"),
  '~contains~2~contains~4~contains~10': Mode(className: "string", begin: "0\\'(\\\\\\'|.)"),
  '~contains~2~contains~4': Mode(begin: "\\[", end: "\\]", contains: [Mode(ref: '~contains~0'), Mode(ref: '~contains~1'), Mode(ref: '~contains~2'), Mode(ref: '~contains~2~contains~3'), Mode(ref: '~contains~2~contains~4'), Mode(ref: '~contains~2~contains~4~contains~5'), cBlockCommentMode, quoteStringMode, aposStringMode, Mode(ref: '~contains~2~contains~4~contains~9'), Mode(ref: '~contains~2~contains~4~contains~10'), Mode(ref: '~contains~2~contains~4~contains~11'), cNumberMode]),
  '~contains~2~contains~3': Mode(begin: ":-"),
  '~contains~2': Mode(begin: "\\(", end: "\\)", relevance: 0, contains: [Mode(ref: '~contains~0'), Mode(ref: '~contains~1'), Mode(ref: '~contains~2'), Mode(ref: '~contains~2~contains~3'), Mode(ref: '~contains~2~contains~4'), Mode(ref: '~contains~2~contains~4~contains~5'), cBlockCommentMode, quoteStringMode, aposStringMode, Mode(ref: '~contains~2~contains~4~contains~9'), Mode(ref: '~contains~2~contains~4~contains~10'), Mode(ref: '~contains~2~contains~4~contains~11'), cNumberMode]),
  '~contains~1': Mode(className: "symbol", variants: [Mode(begin: "[A-Z][a-zA-Z0-9_]*"), Mode(begin: "_[A-Za-z0-9_]*")], relevance: 0),
  '~contains~0': Mode(begin: "[a-z][A-Za-z0-9_]*", relevance: 0),
}, contains: [
  Mode(ref: '~contains~0'),
  Mode(ref: '~contains~1'),
  Mode(ref: '~contains~2'),
  Mode(ref: '~contains~2~contains~3'),
  Mode(ref: '~contains~2~contains~4'),
  Mode(ref: '~contains~2~contains~4~contains~5'),
  cBlockCommentMode,
  quoteStringMode,
  aposStringMode,
  Mode(ref: '~contains~2~contains~4~contains~9'),
  Mode(ref: '~contains~2~contains~4~contains~10'),
  Mode(ref: '~contains~2~contains~4~contains~11'),
  cNumberMode,
  Mode(begin: "\\.\$")
]);
